/** stores the actuell view number of the module */
var current = 1;

/**
 * Creates  a XML-Request-Object
 */
if (window.XMLHttpRequest){
    xmlHttp = new window.XMLHttpRequest();
} else  { // Internet Explorer 5/6
    xmlHttp = new ActiveXObject("Microsoft.XMLHTTP");
}

/**
 * Domain-Request
 */
function sendHostRequest(host){

    url = "/proxy/index.htm?control=result&host=" + host + "&current=" + current;
  
    xmlHttp.open("GET", url , true);
    xmlHttp.onreadystatechange = function(){
        if(xmlHttp.readyState == 4){
            if(xmlHttp.status == 200){
                document.getElementById('result').innerHTML = xmlHttp.responseText;
                document.getElementById('resultHeadline').innerHTML = host;
            }
        }
    }
    xmlHttp.send(null);
}

/**
 * Main-Domain-Request
 */
function sendHostsRequest(host){
   
    url = "/proxy/index.htm?control=result&mainDomain=" + host + "&current=" + current;
   
    xmlHttp.open("GET", url , true);
    xmlHttp.onreadystatechange = function(){
        if(xmlHttp.readyState == 4){
            if(xmlHttp.status == 200){
                document.getElementById('result').innerHTML = xmlHttp.responseText;
            }
        }
    }
    xmlHttp.send(null);
}

/**
 * Ajax-Search
 */
function sendSearchRequest(){

    if(document.fl.query.value != ""){ // only generate Traffic, if Field is not empty
        var selectedVar = document.getElementById('selected').value;

        if(selectedVar == "Hauptdom\xE4ne" ) {
            url = "/proxy/index.htm?control=searchResult&selected=0&name=" + escape(document.fl.query.value.toLowerCase());
        } else if (selectedVar == "Dom\xE4ne"){
            url = "/proxy/index.htm?control=searchResult&selected=1&name=" + escape(document.fl.query.value.toLowerCase());
        } else {
            url = "/proxy/index.htm?control=searchResult&selected=2&name=" + escape(document.fl.query.value.toLowerCase());
        }

        xmlHttp.open("get", url, true);
        xmlHttp.send(null);
        xmlHttp.onreadystatechange = function(){
            if(xmlHttp.readyState == 4){
                if(xmlHttp.status == 200){
                    document.getElementById("search_response").style.visibility = "visible";
                    document.getElementById('search_response').innerHTML = xmlHttp.responseText;
                }
            }        
        }
    } else {
        document.getElementById("search_response").style.visibility = "hidden";
    }
}


/**
 * Get Search Result. Funktion, getting the value of the input-field and
 * calls sendHostRequest or sendValueSearchRequest. Finally clears Assumption.
 */
function getSearchResult(){
    var search = document.getElementById('searchSelect').value;
    if(search.length != 0){
        document.getElementById('query').value = document.getElementById('searchSelect').value;
    }

    var query = document.getElementById('query').value;
    
    var selectedVar = document.getElementById('selected').value;
    // comparison with "Umlaut"
    if(selectedVar == "Hauptdom\xE4ne" ) {
        sendHostsRequest(query);
    } else if (selectedVar == "Dom\xE4ne"){
        sendHostRequest(query);
    } else {
        sendValueSearchRequest(query);
    }

    document.getElementById('search_response').innerHTML = "";
}


/**
 * Send Value Search Request. Uses a POST-Request and url-encoded, so we make
 * sure that urls can also be send corretly in the search
 */
function sendValueSearchRequest(value){
   
    url = "/proxy/index.htm?control=result&current=" + current;
    value = encodeURIComponent(value);

    param='value=' + value;

    xmlHttp.open("POST", url , true);
    xmlHttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");   
    xmlHttp.send(param);

    xmlHttp.onreadystatechange = function(){
        if(xmlHttp.readyState == 4){
            if(xmlHttp.status == 200){
                document.getElementById('result').innerHTML = xmlHttp.responseText;
                // to clear seach-field
                document.getElementById('search_response').innerHTML = "";
            }
        }
    }
    xmlHttp.send(null);
    
}





/**
 * Set Module-Visibility. Also Changes the Color of the Menu-Boxes client-side.
 */

function setModuleVisibility(val){
    // saves User-Choice
    current = val;
    var cnt = 1;

    while(true){
        // break if there are no more container-divs
        if(document.getElementById('container' + cnt) == null){
            return;
        } else {
            // set the coosen div visible, and hide all others
            if(val == cnt){
                document.getElementById('container' + cnt).style.display = "block";
                document.getElementById('box' + cnt).style.background = "#BED630";
                document.getElementById('boxSp' + cnt).style.borderLeft="10px solid #BED630";
            } else {
                document.getElementById('container' + cnt).style.display = "none";
                document.getElementById('box' + cnt).style.background = "#B3CAE3";
                document.getElementById('boxSp' + cnt).style.borderLeft = "10px solid #B3CAE3";

            }
            cnt++;
        }
    }
}

/** stores the actuell view number */
var cView = 0;

/** Set Result Before Visibility */
function setResultBeforeVisibility(width, length){
    
    cView--; 
     
    if(cView <= 0){
        cView = 0;
    }

    for(var i = 1; i <= width; i++){
        for(var j = 0; j < length; j++){
            // change visibilitiy
            if( document.getElementById('resultView' + i + "," + j) != null){
                if(current == i && cView == j){                        
                    document.getElementById('resultView' + i + "," + j).style.display="block";               
                } else {
                    document.getElementById('resultView' + i + "," + j).style.display="none";
                }
            }
        }
    }
}

/** Set Result View Visibility */
function setResultViewVisibility(chosen, width, length){  

    for(var i = 1; i <= width; i++){
        for(var j = 0; j < length; j++){
         
            if( document.getElementById('resultView' + i + "," + j) != null){
                if(current == i && chosen == j){ 
                    document.getElementById('resultView' + i + "," + j).style.display="block";
                    cView = chosen;
                } else {
                    document.getElementById('resultView' + i + "," + j).style.display="none";
                }
            }
        }
    }

}

/** Set Result After Visibility */
function setResultAfterVisibility(width, length){
  
    cView++;

    if(cView >= (length -1)){
        cView = length -1;
    }

    for(var i = 1; i <= width; i++){
        for(var j = 0; j < length; j++){

            if( document.getElementById('resultView' + i + "," + j) != null){
                if(current == i && cView == j){          
                    document.getElementById('resultView' + i + "," + j).style.display="block";        
                } else {
                    document.getElementById('resultView' + i + "," + j).style.display="none";
                }
            }
        }
    }

}

/* --------------------- home -------------------------------------------- */
/**
 * Onload sets the default Colors of the Browser-Navigation
 */
function onload() {
    if(document.getElementById('hd') != null &&
        document.getElementById('d') != null){
        document.getElementById('hd').style.background = "#BED630";
        document.getElementById('hd').style.color="#000000";

        document.getElementById('d').style.background = "#B3CAE3";
        document.getElementById('d').style.color="#034EA2";
    }
}

/**
 * change between Main-Domains and Domains
 */
function setVisibilityBrowserNavi(val){
    if(val=='0'){
        // change visibilitiy
        document.getElementById('mainDomains').style.display="block";
        document.getElementById('domains').style.display="none";
        // change the Color
        // Active-Colors
        document.getElementById('hd').style.background = "#BED630";
        document.getElementById('hd').style.color="#000000";
        // Inactive-Colors
        document.getElementById('d').style.background = "#B3CAE3";
        document.getElementById('d').style.color="#034EA2";
    } else {
        // change visibilitiy
        document.getElementById('mainDomains').style.display="none";
        document.getElementById('domains').style.display="block";
        // change the Color
        // Active-Colors
        document.getElementById('d').style.background = "#BED630";
        document.getElementById('d').style.color="#000000";
        // Inactive-Colors
        document.getElementById('hd').style.background = "#B3CAE3";
        document.getElementById('hd').style.color="#034EA2";
    }

}

/* --------------------- view -------------------------------------------- */
/** stores the actuell view number */
var currentView = 0;

/**
 * SubmitLink. Function, we use to send this link, so that it can submit
 * the js-Variable currentView
 */
function submitLink (url){

    url = url + '&currentView=' + currentView;
    window.location = url;
}

/**
 * Set Before Visibility
 */
function setBeforeVisibility(length){

    var val = currentView - 1;

    if(val <= 0){
        val = 0;
    }
    
    for(var i = 0; i< length; i++){
        // change visibilitiy
        if(i == val){
            document.getElementById('view' + i).style.display="block";
            currentView = val;
        } else {
            document.getElementById('view' + i).style.display="none";
        }
    }

}

/**
 * Set View Visibility
 */
function setViewVisibility(val, length){

    for(var i = 0; i< length; i++){
        if(i == val){
            document.getElementById('view' + i).style.display="block";
            currentView = val;
        } else {
            document.getElementById('view' + i).style.display="none";
        }
    }

}

/**
 * Set After Visibility
 */
function setAfterVisibility(length){

    var val = currentView + 1;

    if(val >= length){
        val = length -1;
    }
   
    for(var i = 0; i< length; i++){
        // change visibilitiy
        if(i == val){
            document.getElementById('view' + i).style.display="block";
            currentView = val;
        } else {
            document.getElementById('view' + i).style.display="none";
        }
    }

}

/* --------------------- Delete Analyse ---------------------------------- */
/**
 * Delete Analyse
 */
function deleteAnalyse(){

    document.getElementById('message').innerHTML = "";
    document.getElementById('deleteAnalyseMain').style.display="none";
    document.getElementById('confirmDeleteAnalyse').style.display="block";
}

/**
 * Confirm Delete Analyse
 */
function confirmDeleteAnalyse(){

    var url = 'controller.htm?control=dataControl&delete=true';
    window.location = url;
   
    document.getElementById('deleteAnalyseMain').style.display="block";
    document.getElementById('confirmDeleteAnalyse').style.display="none";
    document.getElementById('message').innerHTML = "Auswertungsdaten wurden gel&ouml;scht<br/><br/>";

}

/**
 * Stop Delete Analyse
 */
function stopDeleteAnalyse(){
  
    document.getElementById('deleteAnalyseMain').style.display="block";
    document.getElementById('confirmDeleteAnalyse').style.display="none";
    document.getElementById('message').innerHTML = "<span class=\"error\"> Auswertungsdaten l&ouml;schen abgebrochen<br/><br/></span>";

}